package space.eptaproject.vmodextras.compact;

import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Items;
import net.minecraftforge.registries.RegistryObject;
import space.eptaproject.vmodextras.VmodExtras;
import space.eptaproject.vmodextras.compact.computercraft.ComputerCraftCompact;
import space.eptaproject.vmodextras.compact.trackwork.TrackWorkCompact;
import space.eptaproject.vmodextras.util.ModRegistry;
import space.eptaproject.vmodextras.util.Utils;

import java.util.function.BiConsumer;

public class Compact {
    public static RegistryObject<CreativeModeTab> COMPACT_TAB;

    public Compact(BiConsumer<ModRegistry, ModRegistry.TabBuilder> consumer) {
        ModRegistry REGISTRY = VmodExtras.REGISTRY;
        ModRegistry.TabBuilder builder = REGISTRY.TabBuilder();

        Utils.executeIsModEnable("computercraft", () -> {
            ComputerCraftCompact.init(REGISTRY, builder);
        });

        Utils.executeIsModEnable("trackwork", () -> {
            TrackWorkCompact.init(REGISTRY, builder);
        });

        consumer.accept(REGISTRY, builder);

        COMPACT_TAB = builder.build("vmodextras", Items.PAPER.getDefaultInstance());
    }
}
