package space.eptaproject.vmodextras.compact.computercraft;

import net.minecraft.world.item.BlockItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.MapColor;
import net.minecraftforge.registries.RegistryObject;
import space.eptaproject.vmodextras.compact.computercraft.block.TrackWorkController;
import space.eptaproject.vmodextras.compact.computercraft.block.entity.TrackWorkControllerEntity;
import space.eptaproject.vmodextras.util.ModRegistry;
import space.eptaproject.vmodextras.util.Utils;

public class ComputerCraftCompact {
    public static RegistryObject<BlockEntityType<TrackWorkControllerEntity>> TRACK_WORK_CONTROLLER_BLOCK_ENTITY;

    public static RegistryObject<Block> TRACK_WORK_CONTROLLER_BLOCK;
    public static RegistryObject<Item> TRACK_WORK_CONTROLLER_ITEM;

    public static void init(ModRegistry REGISTRY, ModRegistry.TabBuilder builder) {
        Utils.executeIsModEnable("trackwork", () -> {
            TRACK_WORK_CONTROLLER_BLOCK = REGISTRY.BLOCKS.register("track_work_controller", () -> new TrackWorkController(BlockBehaviour.Properties.of().mapColor(MapColor.STONE)));
            TRACK_WORK_CONTROLLER_BLOCK_ENTITY = REGISTRY.BLOCK_ENTITIES.register("track_work_controller", () -> BlockEntityType.Builder.of(TrackWorkControllerEntity::new, TRACK_WORK_CONTROLLER_BLOCK.get()).build(null));
        });

        builder.push((registry) -> {
            Utils.executeIsModEnable("trackwork", () -> {
                TRACK_WORK_CONTROLLER_ITEM = registry.register("track_work_controller", () -> new BlockItem(TRACK_WORK_CONTROLLER_BLOCK.get(), new Item.Properties().rarity(Rarity.EPIC)));
            });
        });
    }
}
