package space.eptaproject.vmodextras.compact.computercraft.block.entity;

import dan200.computercraft.api.peripheral.IPeripheral;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.util.LazyOptional;
import org.jetbrains.annotations.NotNull;
import space.eptaproject.vmodextras.compact.computercraft.ComputerCraftCompact;
import space.eptaproject.vmodextras.compact.computercraft.peripheral.TrackWorkControllerPeripheral;

import static dan200.computercraft.shared.Capabilities.CAPABILITY_PERIPHERAL;

public class TrackWorkControllerEntity extends BlockEntity {
    public TrackWorkControllerEntity(BlockPos p_155229_, BlockState p_155230_) {
        super(ComputerCraftCompact.TRACK_WORK_CONTROLLER_BLOCK_ENTITY.get(), p_155229_, p_155230_);
    }

    protected TrackWorkControllerPeripheral peripheral = new TrackWorkControllerPeripheral(this);
    private LazyOptional<IPeripheral> peripheralCap;

    @Override
    @NotNull
    public <T> LazyOptional<T> getCapability(@NotNull Capability<T> cap, Direction direction) {
        if (cap == CAPABILITY_PERIPHERAL) {
            if (peripheralCap == null) {
                peripheralCap = LazyOptional.of(() -> peripheral);
            }
            return peripheralCap.cast();
        }
        return super.getCapability(cap, direction);
    }

    @Override
    public void invalidateCaps() {
        super.invalidateCaps();
        peripheralCap.invalidate();
    }
}
