package space.eptaproject.vmodextras.compact.computercraft.peripheral;

import dan200.computercraft.api.lua.*;
import edn.stratodonut.trackwork.tracks.forces.SimpleWheelController;
import it.unimi.dsi.fastutil.ints.Int2DoubleArrayMap;
import it.unimi.dsi.fastutil.ints.Int2DoubleMap;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import org.joml.Vector3d;
import org.joml.Vector3dc;
import org.valkyrienskies.core.api.ships.ServerShip;
import org.valkyrienskies.mod.common.VSGameUtilsKt;
import space.eptaproject.vmodextras.compact.computercraft.block.entity.TrackWorkControllerEntity;
import space.eptaproject.vmodextras.compact.trackwork.ISimpleWheelController;

import java.util.List;
import java.util.Objects;

public class TrackWorkControllerPeripheral extends PeripheralBase {
    private TrackWorkControllerEntity entity;

    public static class Controller<T> {
        private final Class<T> contoller;
        private Controller(Class<T> contoller) {
            this.contoller = contoller;
        }

        public Class<T> getContoller() {
            return contoller;
        }

        public T get(ServerShip ship) {
            Objects.requireNonNull(ship);
            T t = ship.getAttachment(contoller);
            if (t == null) {
                try {
                    t = contoller.getDeclaredConstructor().newInstance();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            Objects.requireNonNull(t);
            return t;
        }

        public static final List<Controller<?>> DEFS = new ObjectArrayList<>();
    }

    public TrackWorkControllerPeripheral(TrackWorkControllerEntity entity) {
        super("track_work_controller");
        this.entity = entity;
    }

    @LuaFunction
    public final void SetSuspensionAdjust(IArguments arguments) throws LuaException {
        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.entity.getLevel(), this.entity.getBlockPos());
        if (ship != null) {
            ((ISimpleWheelController) SimpleWheelController.getOrCreate(ship)).setSuspensionAdjust(new Vector3d(
                    Math.max(Math.min(arguments.getDouble(0), 1d), 0d),
                    Math.max(Math.min(arguments.getDouble(1), 1.3d), 0.5d),
                    Math.max(Math.min(arguments.getDouble(2), 1d), 0d)
            ));
        }
    }

    @LuaFunction
    public final MethodResult GetSuspensionAdjust(IArguments arguments) throws LuaException {
        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.entity.getLevel(), this.entity.getBlockPos());
        if (ship != null) {
            Vector3dc vec =((ISimpleWheelController) SimpleWheelController.getOrCreate(ship)).getSuspensionAdjust();
            Int2DoubleMap map = new Int2DoubleArrayMap();
            map.put(1, vec.x());
            map.put(2, vec.y());
            map.put(3, vec.z());
            return MethodResult.of(new ObjectLuaTable(map));
        }

        return MethodResult.of();
    }

    @LuaFunction
    public final MethodResult GetMeta(IArguments arguments) throws LuaException {
        return MethodResult.of();
    }
}
