package space.eptaproject.vmodextras.compact.trackwork;

import net.minecraft.world.item.BlockItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.MapColor;
import net.minecraftforge.registries.RegistryObject;
import space.eptaproject.vmodextras.compact.trackwork.block.CompactBackupBlock;
import space.eptaproject.vmodextras.compact.trackwork.block.TrackBackupBlock;
import space.eptaproject.vmodextras.compact.trackwork.block.entity.CompactBackupBlockEntity;
import space.eptaproject.vmodextras.compact.trackwork.block.entity.TrackBackupBlockEntity;
import space.eptaproject.vmodextras.util.ModRegistry;

public class TrackWorkCompact
{
    public static RegistryObject<Block> SHIP_VOID_BLOCK;
    public static RegistryObject<Block> TRAK_BUK;
    public static RegistryObject<Block> COMPACT_BACKUP;

    public static RegistryObject<BlockEntityType<TrackBackupBlockEntity>> MY_BLOCK_ENTITY;
    public static RegistryObject<BlockEntityType<CompactBackupBlockEntity>> COMPACT_BACKUP_BLOCK_ENTITY;

    public static RegistryObject<Item> MY_BLOCK_ITEM;
    public static RegistryObject<Item> SHIP_VOID_ITEM;
    public static RegistryObject<Item> COMPACT_BACKUP_ITEM;

    public static void init(ModRegistry REGISTRY, ModRegistry.TabBuilder builder) {
        TRAK_BUK = REGISTRY.BLOCKS.register("track_backup", () -> new TrackBackupBlock(BlockBehaviour.Properties.of().mapColor(MapColor.STONE)));
        SHIP_VOID_BLOCK = REGISTRY.BLOCKS.register("ship_void", () -> new Block(BlockBehaviour.Properties.of().mapColor(MapColor.STONE)));
        COMPACT_BACKUP = REGISTRY.BLOCKS.register("compact_backup", () -> new CompactBackupBlock(BlockBehaviour.Properties.of().mapColor(MapColor.STONE)));

        MY_BLOCK_ENTITY = REGISTRY.BLOCK_ENTITIES.register("track_backup", () -> BlockEntityType.Builder.of(TrackBackupBlockEntity::new, TRAK_BUK.get()).build(null));
        COMPACT_BACKUP_BLOCK_ENTITY = REGISTRY.BLOCK_ENTITIES.register("compact_backup", () -> BlockEntityType.Builder.of(CompactBackupBlockEntity::new, COMPACT_BACKUP.get()).build(null));

        builder.push((registry) -> {
            MY_BLOCK_ITEM = registry.register("track_backup", () -> new BlockItem(TRAK_BUK.get(), new Item.Properties().rarity(Rarity.EPIC)));
            SHIP_VOID_ITEM = registry.register("ship_void", () -> new BlockItem(SHIP_VOID_BLOCK.get(), new Item.Properties()));
            COMPACT_BACKUP_ITEM = registry.register("compact_backup", () -> new BlockItem(COMPACT_BACKUP.get(), new Item.Properties().rarity(Rarity.EPIC)));
        });
    }
}
