package space.eptaproject.vmodextras.compact.trackwork.block.entity;

import edn.stratodonut.trackwork.tracks.forces.PhysicsTrackController;
import edn.stratodonut.trackwork.tracks.forces.SimpleWheelController;
import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import org.valkyrienskies.core.api.ships.ServerShip;
import org.valkyrienskies.mod.common.VSGameUtilsKt;
import space.eptaproject.vmodextras.compact.trackwork.TrackWorkCompact;
import space.eptaproject.vmodextras.compact.trackwork.IPhysicsTrackController;
import space.eptaproject.vmodextras.compact.trackwork.ISimpleWheelController;
import space.eptaproject.vmodextras.compact.trackwork.IBlockEntityClear;

public class TrackBackupBlockEntity extends BlockEntity implements IBlockEntityClear {
    public TrackBackupBlockEntity(BlockPos p_155229_, BlockState p_155230_) {
        super(TrackWorkCompact.MY_BLOCK_ENTITY.get(), p_155229_, p_155230_);
    }

    public CompoundTag tag = new CompoundTag();

    @Override
    public boolean clear() {
        try {
            CompoundTag local = tag.copy();
            if (local.contains("SimpleWheelController")) {
                CompoundTag SimpleWheelControllerTag = new CompoundTag();

                SimpleWheelControllerTag.putFloat("SuspensionStiffness", 1);
                {
                    CompoundTag suspensionAdjust = new CompoundTag();

                    suspensionAdjust.putDouble("x", 0);
                    suspensionAdjust.putDouble("y", 1);
                    suspensionAdjust.putDouble("z", 0);

                    SimpleWheelControllerTag.put("suspensionAdjust", suspensionAdjust);
                }

                tag.put("SimpleWheelController", SimpleWheelControllerTag);
            }

            if (local.contains("PhysicsTrackController")) {
                CompoundTag PhysicsTrackControllerTag = new CompoundTag();

                PhysicsTrackControllerTag.putFloat("SuspensionStiffness", 1);
                {
                    CompoundTag suspensionAdjust = new CompoundTag();


                    suspensionAdjust.putDouble("x", 0);
                    suspensionAdjust.putDouble("y", 1);
                    suspensionAdjust.putDouble("z", 0);

                    PhysicsTrackControllerTag.put("suspensionAdjust", suspensionAdjust);
                }

                tag.put("PhysicsTrackController", PhysicsTrackControllerTag);
            }
            return true;
        } catch (Exception e) {
            return false;
        }
    }

    @Override
    protected void saveAdditional(CompoundTag tag) {
        this.tag = tag;
        super.saveAdditional(tag);
        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
        if (ship != null) {
            {
                PhysicsTrackController physicsTrackController = ship.getAttachment(PhysicsTrackController.class);
                if (physicsTrackController != null) {
                    IPhysicsTrackController controller = (IPhysicsTrackController) physicsTrackController;
                    CompoundTag local = new CompoundTag();

                    controller.encode(local);

                    tag.put("PhysicsTrackController", local);
                }
            }

            {
                SimpleWheelController simpleWheelController = ship.getAttachment(SimpleWheelController.class);
                if (simpleWheelController != null) {
                    ISimpleWheelController controller = (ISimpleWheelController) simpleWheelController;
                    CompoundTag local = new CompoundTag();

                    controller.encode(local);

                    tag.put("SimpleWheelController", local);
                }
            }
        }
    }

    @Override
    public void load(CompoundTag tag) {
        this.tag = tag;
        super.load(tag);
        ServerShip ship = (ServerShip) VSGameUtilsKt.getShipObjectManagingPos(this.level, getBlockPos());
        if (ship != null) {
            if (tag.contains("SimpleWheelController", Tag.TAG_COMPOUND)) {
                ((ISimpleWheelController) SimpleWheelController.getOrCreate(ship)).decode(tag.getCompound("SimpleWheelController"));
            }

            if (tag.contains("PhysicsTrackController", Tag.TAG_COMPOUND)) {
                ((IPhysicsTrackController) PhysicsTrackController.getOrCreate(ship)).decode(tag.getCompound("PhysicsTrackController"));
            }
        }
    }
}
